SystemOrganization addCategory: #'Kumpel-Tests-Core'!

PPCompositeParserTest subclass: #PPDiffParserTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Kumpel-Tests-Core'!

!PPDiffParserTest methodsFor: 'as yet unclassified' stamp: 'Matthias Junker 2/28/2010 14:07'!
parserClass
	^ PPDiffParser ! !

!PPDiffParserTest methodsFor: 'as yet unclassified' stamp: 'MatthiasJunker 3/4/2010 23:52'!
testChunk
	| result |
	result := PPDiffParser new chunk parse:  #( '@@ -1,3 +1,3 @@' '-abc' '+a1' ' bde' ' cif') asContent .
	self assert: result content first = #( $- 'abc' ).
	self assert: result content second = #( $+ 'a1' ).
	self assert: result content third = { Character space . 'bde' }.
	self assert: result content fourth = { Character space . 'cif' }. ! !

!PPDiffParserTest methodsFor: 'as yet unclassified' stamp: 'MatthiasJunker 3/4/2010 23:52'!
testChunkContent
	self assert: (PPDiffParser new chunkContent  parse: 	( #( ' abc'  '+def'  '-ghj' ) asContent )) 
						= (Array with: (Array with:  Character space with: 'abc') 
									with: (Array with: $+ with: 'def') 
									 with: (Array with: $- with: 'ghj')).
! !

!PPDiffParserTest methodsFor: 'as yet unclassified' stamp: 'MatthiasJunker 3/3/2010 00:27'!
testChunkContentWithChunkInfo
	| content diffChunkInfo|
	"Tests whether a chunk which contains text which looks like chunk information (e.g. diff from a patch) is properly parsed "

	diffChunkInfo := '@@ -1,10 +1,10 @@'.
	content := ' line1' , Character lf asSymbol  , Character space asSymbol  , diffChunkInfo .
	self assert: (PPDiffParser new chunkContent parse: 
			content ,  Character lf asSymbol, diffChunkInfo) 
								= (Array with: (Array with: Character space with: 'line1' ) 
											with: (Array with: Character space with: diffChunkInfo) )! !

!PPDiffParserTest methodsFor: 'as yet unclassified' stamp: 'MatthiasJunker 3/3/2010 00:42'!
testChunkDetail
	
	self assert: (PPDiffParser new chunkDetail parse: '@@ -1,2 +3,4 @@' , Character cr asSymbol)
								= (Array with: (Array with: 1 with: 2) with: (Array with: 3 with: 4))! !

!PPDiffParserTest methodsFor: 'as yet unclassified' stamp: 'MatthiasJunker 3/19/2010 09:02'!
testChunkWithNoNewLineAtEndOfFile
| diff |
"tests that the special line \ No newline at end of file is removed properly"
diff := PPDiffParser new fileDiff parse: 
'Index: deprecated.c
===================================================================
--- deprecated.c	(revision 879867)
+++ deprecated.c	(revision 879886)
@@ -141,4 +141,4 @@
                                      conflict_separator,
                                      style,
                                      pool);
-}
\ No newline at end of file
+}'.
self assert: diff chunks first content size = 5! !

!PPDiffParserTest methodsFor: 'as yet unclassified' stamp: 'MatthiasJunker 3/19/2010 08:36'!
testChunkWithProperties
PPDiffParser new parse: 
'Index: diff_file.c
===================================================================
--- diff_file.c	(revision 848990)
+++ diff_file.c	(revision 849000)
@@ -185,7 +185,6 @@
 {
   svn_diff__file_baton_t *file_baton = baton;
   int idx;
-  apr_status_t apr_err;
   apr_finfo_t finfo;
   apr_size_t length;
   char *curp;

Property changes on: token.c
___________________________________________________________________
Added: svn:eol-style
   + native


Property changes on: lcs.c
___________________________________________________________________
Added: svn:eol-style
   + native


Property changes on: util.c
___________________________________________________________________
Added: svn:eol-style
   + native

Index: token.c
===================================================================
--- token.c	(revision 849034)
+++ token.c	(revision 849507)
@@ -157,7 +157,8 @@
   hash = 0; /* The callback fn doesn'' t need to touch it per se */
   while (1)
     {
-      SVN_ERR(vtable->datasource_get_next_token(&hash, &token, diff_baton, datasource));
+      SVN_ERR(vtable->datasource_get_next_token(&hash, &token, 
+                                                diff_baton, datasource));
       if (token == NULL)
         break;
 '! !

!PPDiffParserTest methodsFor: 'as yet unclassified' stamp: 'MatthiasJunker 3/3/2010 00:37'!
testDelimiter
	self assert: (PPDiffParser new delimiter parse: '/') = (Array with: $/).
	self assert: (PPDiffParser new delimiter parse: '\') = (Array with: $\).! !

!PPDiffParserTest methodsFor: 'as yet unclassified' stamp: 'MatthiasJunker 3/21/2010 12:27'!
testDiffWithoutChunks
| result |
result := PPDiffParser new fileDiff parse: 
'Index: libsvn_wc/libsvn_wc.dsp
===================================================================
Cannot display: file marked as a binary type.
svn:mime-type = application/octet-stream

Property changes on: libsvn_wc/libsvn_wc.dsp
___________________________________________________________________
Added: svn:mime-type
   + application/octet-stream


Property changes on: libsvn_wc
___________________________________________________________________
Modified: svn:ignore
   - ChangeLog*
Makefile.in

'.
self assert: result = nil.! !

!PPDiffParserTest methodsFor: 'as yet unclassified' stamp: 'Matthias Junker 2/28/2010 15:43'!
testFileName
	| path |
	path := 'ab-c/cd_e/abc.txt'.
	self assert: (PPDiffParser new fileName  parse: path ) =  path.
! !

!PPDiffParserTest methodsFor: 'as yet unclassified' stamp: 'Matthias Junker 2/28/2010 16:36'!
testFileRevision

	self assert: (PPDiffParser new fileRevision  parse: '(revision 12)' ) = 12.
! !

!PPDiffParserTest methodsFor: 'as yet unclassified' stamp: 'Matthias Junker 2/28/2010 23:39'!
testHeader
	self assert: (PPDiffParser new header parse: 	
		'Index: QSequenceDiscardingMediaConfusionDetector.java' , Character cr asSymbol ,	'===================================================================') 
											= 'QSequenceDiscardingMediaConfusionDetector.java'! !

!PPDiffParserTest methodsFor: 'as yet unclassified' stamp: 'MatthiasJunker 3/3/2010 00:31'!
testLine
	| line |
	line := 'abc'.
	self assert: (PPDiffParser new line parse:  Character space asSymbol , line , Character cr asSymbol ) 
											= (Array with: Character space with: line).

	self assert: (PPDiffParser new line parse: #+  , line , Character cr asSymbol ) 
											= (Array with: $+ with: line).
											
	self assert: (PPDiffParser new line parse:  #- , line , Character cr asSymbol ) 
											= (Array with:  $- with: line).! !

!PPDiffParserTest methodsFor: 'as yet unclassified' stamp: 'MatthiasJunker 3/3/2010 00:40'!
testNewFileChunkPosition
	self assert: (PPDiffParser new newFileChunkPosition  parse: '+12,34') 
											= (Array with: 12 with: 34)! !

!PPDiffParserTest methodsFor: 'as yet unclassified' stamp: 'Matthias Junker 3/1/2010 02:20'!
testNewFileDetails
	self assert: (PPDiffParser new newFileDetails parse: '+++ QSequenceIntMedia.java	(revision 4610)') 
											= (Array with: 'QSequenceIntMedia.java' with: 4610 ).
! !

!PPDiffParserTest methodsFor: 'as yet unclassified' stamp: 'MatthiasJunker 3/3/2010 00:41'!
testOldFileChunkPosition
	self assert: (PPDiffParser new oldFileChunkPosition  parse: '-12,34') 
											= (Array with: 12 with: 34)! !

!PPDiffParserTest methodsFor: 'as yet unclassified' stamp: 'Matthias Junker 3/1/2010 02:20'!
testOldFileDetails
	self assert: (PPDiffParser new oldFileDetails parse: '--- QSequenceIntMedia.java	(revision 4610)') 
											= (Array with: 'QSequenceIntMedia.java' with: 4610).
! !

!PPDiffParserTest methodsFor: 'as yet unclassified' stamp: 'MatthiasJunker 3/21/2010 11:10'!
testSingleNumberInChunkDetail
| result |
result := PPDiffParser new fileDiff parse: 
'Index: tests/libsvn_vcdiff/target1.txt
===================================================================
--- tests/libsvn_vcdiff/target1.txt	(revision 0)
+++ tests/libsvn_vcdiff/target1.txt	(revision 836628)
@@ -0,0 +1 @@
+abcdefghijklxxxxmnopqrstuvwxyz
\ No newline at end of file
'.
self assert: result chunks first newFileRangeStart = 0.
self assert: result chunks first newFileRangeSize = 1.! !

!PPDiffParserTest methodsFor: 'as yet unclassified' stamp: 'MatthiasJunker 3/19/2010 15:18'!
testTwoNewLines
	| result |
	result := PPDiffParser new oneOrTwoLines parse: Character lf asString, Character cr asString.
	self assert: result first  = Character lf.
	self assert: result second  = Character cr.! !

!PPDiffParserTest methodsFor: 'as yet unclassified' stamp: 'MatthiasJunker 3/19/2010 16:00'!
testTwoNewLinesWithProperties
PPDiffParser new parse:
'Index: libsvn_diff/libsvn_diff.dsp
===================================================================
--- libsvn_diff/libsvn_diff.dsp	(revision 0)
+++ libsvn_diff/libsvn_diff.dsp	(revision 845687)
@@ -0,0 +1,102 @@
+# Microsoft Developer Studio Project File - Name="libsvn_diff" - Package Owner=<4>
+# Microsoft Developer Studio Generated Build File, Format Version 6.00
+# ** DO NOT EDIT **
+
+# TARGTYPE "Win32 (x86) Static Library" 0x0104
+
+CFG=libsvn_diff - Win32 Debug
+!!MESSAGE This is not a valid makefile. To build this project using NMAKE,
+!!MESSAGE use the Export Makefile command and run
+!!MESSAGE 
+!!MESSAGE NMAKE /f "libsvn_diff.mak".
+!!MESSAGE 
+!!MESSAGE You can specify a configuration when running NMAKE
+!!MESSAGE by defining the macro CFG on the command line. For example:
+!!MESSAGE 
+!!MESSAGE NMAKE /f "libsvn_diff.mak" CFG="libsvn_diff - Win32 Debug"
+!!MESSAGE 
+!!MESSAGE Possible choices for configuration are:
+!!MESSAGE 
+!!MESSAGE "libsvn_diff - Win32 Release" (based on "Win32 (x86) Static Library")
+!!MESSAGE "libsvn_diff - Win32 Debug" (based on "Win32 (x86) Static Library")
+!!MESSAGE 
+
+# Begin Project
+# PROP AllowPerConfigDependencies 0
+# PROP Scc_ProjName ""
+# PROP Scc_LocalPath ""
+CPP=cl.exe
+RSC=rc.exe
+
+!!IF  "$(CFG)" == "libsvn_diff - Win32 Release"
+
+# PROP BASE Use_MFC 0
+# PROP BASE Use_Debug_Libraries 0
+# PROP BASE Output_Dir "Release"
+# PROP BASE Intermediate_Dir "Release"
+# PROP BASE Target_Dir ""
+# PROP Use_MFC 0
+# PROP Use_Debug_Libraries 0
+# PROP Output_Dir "Release"
+# PROP Intermediate_Dir "Release\obj"
+# PROP Target_Dir ""
+# ADD BASE CPP /nologo /W3 /GX /O2 /D "WIN32" /D "NDEBUG" /D "_MBCS" /D "_LIB" /YX /FD /c
+# ADD CPP /nologo /MD /W3 /GX /O2 /I "..\include" /I "..\..\apr\include" /I "..\..\apr-util\include" /I "..\..\apr-util\xml\expat\lib" /I "..\.." /D "NDEBUG" /D "APR_DECLARE_STATIC" /D "APU_DECLARE_STATIC" /D "WIN32" /D "_WINDOWS" /FD /c
+# SUBTRACT CPP /YX
+# ADD BASE RSC /l 0x424 /d "NDEBUG"
+# ADD RSC /l 0x424 /d "NDEBUG"
+BSC32=bscmake.exe
+# ADD BASE BSC32 /nologo
+# ADD BSC32 /nologo
+LIB32=link.exe -lib
+# ADD BASE LIB32 /nologo
+# ADD LIB32 /nologo
+
+!!ELSEIF  "$(CFG)" == "libsvn_diff - Win32 Debug"
+
+# PROP BASE Use_MFC 0
+# PROP BASE Use_Debug_Libraries 1
+# PROP BASE Output_Dir "Debug"
+# PROP BASE Intermediate_Dir "Debug"
+# PROP BASE Target_Dir ""
+# PROP Use_MFC 0
+# PROP Use_Debug_Libraries 1
+# PROP Output_Dir "Debug"
+# PROP Intermediate_Dir "Debug\obj"
+# PROP Target_Dir ""
+# ADD BASE CPP /nologo /W3 /Gm /GX /ZI /Od /D "WIN32" /D "_DEBUG" /D "_MBCS" /D "_LIB" /YX /FD /GZ /c
+# ADD CPP /nologo /MDd /W3 /GX /ZI /Od /I "..\include" /I "..\..\apr\include" /I "..\..\apr-util\include" /I "..\..\apr-util\xml\expat\lib" /I "..\.." /D "SVN_DEBUG" /D "_DEBUG" /D "APR_DECLARE_STATIC" /D "APU_DECLARE_STATIC" /D "WIN32" /D "_WINDOWS" /FD /GZ /c
+# SUBTRACT CPP /YX
+# ADD BASE RSC /l 0x424 /d "_DEBUG"
+# ADD RSC /l 0x424 /d "_DEBUG"
+BSC32=bscmake.exe
+# ADD BASE BSC32 /nologo
+# ADD BSC32 /nologo
+LIB32=link.exe -lib
+# ADD BASE LIB32 /nologo
+# ADD LIB32 /nologo
+
+!!ENDIF 
+
+# Begin Target
+
+# Name "libsvn_diff - Win32 Release"
+# Name "libsvn_diff - Win32 Debug"
+# Begin Group "Source Files"
+
+# PROP Default_Filter "cpp;c;cxx;rc;def;r;odl;idl;hpj;bat"
+# Begin Source File
+
+SOURCE=.\diff.c
+# End Source File
+# Begin Source File
+
+SOURCE=.\diff_file.c
+# End Source File
+# End Group
+# Begin Group "Header Files"
+
+# PROP Default_Filter "h;hpp;hxx;hm;inl"
+# End Group
+# End Target
+# End Project

Property changes on: libsvn_diff/libsvn_diff.dsp
___________________________________________________________________
Added: svn:eol-style
   + CRLF


Property changes on: libsvn_diff
___________________________________________________________________
Added: svn:ignore
   + Debug
Release
*.lo
*.la
.libs
*.o
*~
.*~




'! !

!PPDiffParserTest methodsFor: 'as yet unclassified' stamp: 'Matthias Junker 3/1/2010 02:31'!
testWithMultipleFiles
	"todo turn into test"
PPDiffParser new parse:
'Index: contrib/sequence/src-test/de/regnis/q/sequence/QSequenceDifferenceAssemblyTest.java
===================================================================
--- contrib/sequence/src-test/de/regnis/q/sequence/QSequenceDifferenceAssemblyTest.java	(revision 4094)
+++ contrib/sequence/src-test/de/regnis/q/sequence/QSequenceDifferenceAssemblyTest.java	(revision 4095)
@@ -1,10 +1,10 @@
 /*
  * ====================================================================
- * Copyright (c) 2004 Marc Strapetz, marc.strapetz@smartsvn.com. 
+ * Copyright (c) 2000-2008 SyntEvo GmbH, info@syntevo.com
  * All rights reserved.
  *
- * This software is licensed as described in the file COPYING, which
- * you should have received as part of this distribution. Use is
+ * This software is licensed as described in the file SEQUENCE-LICENSE,
+ * which you should have received as part of this distribution. Use is
  * subject to license terms.
  * ====================================================================
  */
Index: contrib/sequence/src-test/de/regnis/q/sequence/QSequenceDifferenceBlockShifterTest.java
===================================================================
--- contrib/sequence/src-test/de/regnis/q/sequence/QSequenceDifferenceBlockShifterTest.java	(revision 4094)
+++ contrib/sequence/src-test/de/regnis/q/sequence/QSequenceDifferenceBlockShifterTest.java	(revision 4095)
@@ -1,10 +1,10 @@
 /*
  * ====================================================================
- * Copyright (c) 2004 Marc Strapetz, marc.strapetz@smartsvn.com. 
+ * Copyright (c) 2000-2008 SyntEvo GmbH, info@syntevo.com
  * All rights reserved.
  *
- * This software is licensed as described in the file COPYING, which
- * you should have received as part of this distribution. Use is
+ * This software is licensed as described in the file SEQUENCE-LICENSE,
+ * which you should have received as part of this distribution. Use is
  * subject to license terms.
  * ====================================================================
  */
Index: contrib/sequence/src-test/de/regnis/q/sequence/QSequenceAllTests.java
===================================================================
--- contrib/sequence/src-test/de/regnis/q/sequence/QSequenceAllTests.java	(revision 4094)
+++ contrib/sequence/src-test/de/regnis/q/sequence/QSequenceAllTests.java	(revision 4095)
@@ -1,10 +1,10 @@
 /*
  * ====================================================================
- * Copyright (c) 2004 Marc Strapetz, marc.strapetz@smartsvn.com. 
+ * Copyright (c) 2000-2008 SyntEvo GmbH, info@syntevo.com
  * All rights reserved.
  *
- * This software is licensed as described in the file COPYING, which
- * you should have received as part of this distribution. Use is
+ * This software is licensed as described in the file SEQUENCE-LICENSE,
+ * which you should have received as part of this distribution. Use is
  * subject to license terms.
  * ====================================================================
  */
Index: contrib/sequence/src-test/de/regnis/q/sequence/line/QSequenceLineMediaTest.java
===================================================================
--- contrib/sequence/src-test/de/regnis/q/sequence/line/QSequenceLineMediaTest.java	(revision 4094)
+++ contrib/sequence/src-test/de/regnis/q/sequence/line/QSequenceLineMediaTest.java	(revision 4095)
@@ -1,3 +1,14 @@
+/*

+ * ====================================================================

+ * Copyright (c) 2000-2008 SyntEvo GmbH, info@syntevo.com

+ * All rights reserved.

+ *

+ * This software is licensed as described in the file SEQUENCE-LICENSE,

+ * which you should have received as part of this distribution. Use is

+ * subject to license terms.

+ * ====================================================================

+ */

+

 package de.regnis.q.sequence.line;

 

 import java.io.*;

Index: contrib/sequence/src-test/de/regnis/q/sequence/line/QSequenceLineReaderTest.java
===================================================================
--- contrib/sequence/src-test/de/regnis/q/sequence/line/QSequenceLineReaderTest.java	(revision 4094)
+++ contrib/sequence/src-test/de/regnis/q/sequence/line/QSequenceLineReaderTest.java	(revision 4095)
@@ -1,3 +1,14 @@
+/*

+ * ====================================================================

+ * Copyright (c) 2000-2008 SyntEvo GmbH, info@syntevo.com

+ * All rights reserved.

+ *

+ * This software is licensed as described in the file SEQUENCE-LICENSE,

+ * which you should have received as part of this distribution. Use is

+ * subject to license terms.

+ * ====================================================================

+ */

+

 package de.regnis.q.sequence.line;

 

 import java.io.*;

Index: contrib/sequence/src-test/de/regnis/q/sequence/line/QSequenceLineSimplifierTest.java
===================================================================
--- contrib/sequence/src-test/de/regnis/q/sequence/line/QSequenceLineSimplifierTest.java	(revision 4094)
+++ contrib/sequence/src-test/de/regnis/q/sequence/line/QSequenceLineSimplifierTest.java	(revision 4095)
@@ -1,3 +1,14 @@
+/*
+ * ====================================================================
+ * Copyright (c) 2000-2008 SyntEvo GmbH, info@syntevo.com
+ * All rights reserved.
+ *
+ * This software is licensed as described in the file SEQUENCE-LICENSE,
+ * which you should have received as part of this distribution. Use is
+ * subject to license terms.
+ * ====================================================================
+ */
+
 package de.regnis.q.sequence.line;
 
 import junit.framework.*;
'! !

PPCompositeParserTest subclass: #PPLogParserTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Kumpel-Tests-Core'!

!PPLogParserTest methodsFor: 'as yet unclassified' stamp: 'MatthiasJunker 3/12/2010 12:00'!
logContent
	^
'=========================================
author=cmpilato
revision=846070
date=2003-05-20 20:26:55
message=Fix Issue #1318 -- export fails over svn://.  Some silly pool usage,
and some sillier-still sanity checking were to blame.  (with sussman).

* subversion/libsvn_client/export.c
  (struct file_baton): Add pool member.
  (add_file): Stuff the pool into the baton.
  (apply_textdelta): Use the file batons pool to store the tmpfile
    and its path.
  (close_file): Do sanity check *before* doing insane things.

-----------------------------------------
action=M pathString="/subversion/trunk/subversion/libsvn_client/export.c" nodeKind=file copyFromPath="null" copyFromRevision=-1
=========================================
author=philip
revision=846071
date=2003-05-20 21:23:22
message=* tools/dev/stress.pl (status_update_commit): Tidy up the output by
  printing the commit standard output before any commit standard
  error, and by printing the commit standard error to the scripts
  standard output.

-----------------------------------------
action=M pathString="/subversion/trunk/tools/dev/stress.pl" nodeKind=file copyFromPath="null" copyFromRevision=-1
=========================================
author=kfogel
revision=846072
date=2003-05-21 24:11:49
message=Fix another bug in the issue #1302 family, reported by Robert Pluim:

* tools/cvs2svn/cvs2svn.py
  (TreeMirror.delete_path): Dont prune if the single item in the last
    directory is not the desired target.

-----------------------------------------
action=M pathString="/subversion/trunk/tools/cvs2svn/cvs2svn.py" nodeKind=file copyFromPath="null" copyFromRevision=-1
'! !

!PPLogParserTest methodsFor: 'as yet unclassified' stamp: 'MatthiasJunker 2/27/2011 15:36'!
logContent2
	^
'=========================================
author=XXX
revision=30919
date=2009-11-26 13:13:49
message=
-----------------------------------------
action=A pathString="/xxx" nodeKind=unknown copyFromPath="null" copyFromRevision=-1
=========================================
author=XXX
revision=30925
date=2009-11-26 13:17:30
message=
-----------------------------------------
action=A pathString="/xxx/xx" nodeKind=unknown copyFromPath="null" copyFromRevision=-1
=========================================
author=XXX
revision=30926
date=2009-11-26 13:17:44
message=
-----------------------------------------
action=A pathString="/xxx/xx/x" nodeKind=unknown copyFromPath="null" copyFromRevision=-1
=========================================
author=XXX
revision=30927
date=2009-11-26 13:17:57
message=
-----------------------------------------
action=A pathString="/xxx/xx/x/y" nodeKind=unknown copyFromPath="null" copyFromRevision=-1
'! !

!PPLogParserTest methodsFor: 'as yet unclassified' stamp: 'MatthiasJunker 3/5/2010 13:34'!
parserClass
	^ PPLogParser ! !

!PPLogParserTest methodsFor: 'as yet unclassified' stamp: 'MatthiasJunker 3/12/2010 12:00'!
testEntireFile
	| result |
	result := PPLogParser new parse: self logContent.
	self assert: result size = 3.! !

!PPLogParserTest methodsFor: 'as yet unclassified' stamp: 'MatthiasJunker 2/27/2011 15:35'!
testEntireFile2
	result := PPLogParser new parse: self logContent2.
	self assert: result size = 4! !

TestCase subclass: #KMPArrayTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Kumpel-Tests-Core'!

!KMPArrayTest methodsFor: 'as yet unclassified' stamp: 'MatthiasJunker 3/10/2011 23:04'!
testContentFromArray
	self assert: #( ' a'  '+b' '-c') asContent =  (' a' , KMPDiff lineSeparator ,  '+b' , KMPDiff lineSeparator  , '-c' )! !

TestCase subclass: #KMPAuthorTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Kumpel-Tests-Core'!

!KMPAuthorTest methodsFor: 'tests' stamp: 'FelipeGonzlezMartnez 1/10/2012 23:11'!
testAuthorCreation
	| name author version projectHistory testDataBuilder projectVersion2 |
	name := 'test'.
	author := KMPAuthor new: name.
	self assert: author name = name.
	"
	testDataBuilder := KMPTestDataBuilder new.
	projectVersion2 := KMPProjectVersion new: 2.
	testDataBuilder projectHistory addVersion: projectVersion2.
	self assert: projectVersion2 history = testDataBuilder projectHistory.
	self assert: (testDataBuilder projectHistory versions includes: projectVersion2).	
	
	projectHistory = KMPProjectHistory new.
	projectHistory author: author.
	projectHistory versions: version.
	
	author projectHistory: projectHistory.
	
	self assert: author projectHistory = projectHistory.
	
	"! !

TestCase subclass: #KMPDiffChunkTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Kumpel-Tests-Core'!

!KMPDiffChunkTest methodsFor: 'tests' stamp: 'FelipeGonzlezMartnez 1/10/2012 22:09'!
testLineNumberDifferenceToPrevious
	| diffChunk |
	diffChunk := KMPDiffChunk new.
	diffChunk oldFileRangeStart: 1 oldFileRangeSize: 9 newFileRangeStart: 2 newFileRangeSize: 7.
	self assert: diffChunk lineNumberDifferenceToPrevious = -2.
	! !

!KMPDiffChunkTest methodsFor: 'tests' stamp: 'FelipeGonzlezMartnez 1/10/2012 22:12'!
testNewContent
	| diffChunk newContent |
	diffChunk := (PPDiffParser new chunk parse:  #( '@@ -1,3 +1,3 @@' '-a' '+a1' ' b' ' c' ) asContent ).
	newContent := diffChunk newContent.
	
	self assert: newContent size  = 3.
	self assert: newContent first  = #($+ 'a1').
	self assert: newContent second  = {Character space . 'b' }.
	self assert: newContent third  = {Character space . 'c' }.
	
	"added"
	self assert: diffChunk patchedContent = #('a1' 'b' 'c') asOrderedCollection.! !

!KMPDiffChunkTest methodsFor: 'tests' stamp: 'FelipeGonzlezMartnez 1/10/2012 22:16'!
testOldContent
	| diffChunk newContent |
	diffChunk := (PPDiffParser new chunk parse:  #( '@@ -1,3 +1,3 @@' '-a' '+a1' ' b' ' c' ) asContent ).
	newContent := diffChunk oldContent.
	self assert: newContent size  = 3.
	self assert: newContent first  = #($- 'a').
	self assert: newContent second  = {Character space . 'b' }.
	self assert: newContent third  = {Character space . 'c' }.

	"added"
	self assert: diffChunk oldFileRangeSize = 3.
	self assert: diffChunk oldFileRangeStart = 1.! !

TestCase subclass: #KMPDiffTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Kumpel-Tests-Core'!

!KMPDiffTest methodsFor: 'as yet unclassified' stamp: 'MatthiasJunker 3/5/2010 00:02'!
initialContent
	^
'This part of the
document has stayed the
same from version to
version.  It shouldn''t
be shown if it doesn''t
change.  Otherwise, that
would not be helping to
compress the size of the
changes.

This paragraph contains
text that is outdated.
It will be deleted in the
near future.

It is important to spell
check this dokument. On
the other hand, a
misspelled word isn''t
the end of the world.
Nothing in the rest of
this paragraph needs to
be changed. Things can
be added after it.'! !

!KMPDiffTest methodsFor: 'as yet unclassified' stamp: 'MatthiasJunker 3/5/2010 00:03'!
patch1
^'Index: content
======================================
--- content.1	(revision 1)
+++ content.2	(revision 2)
@@ -1,3 +1,9 @@
+This is an important
+notice!! It should
+therefore be located at
+the beginning of this
+document!!
+
 This part of the
 document has stayed the
 same from version to
@@ -5,16 +11,10 @@
 be shown if it doesn''t
 change.  Otherwise, that
 would not be helping to
-compress the size of the
-changes.
-
-This paragraph contains
-text that is outdated.
-It will be deleted in the
-near future.
+compress anything.
 
 It is important to spell
-check this dokument. On
+check this document. On
 the other hand, a
 misspelled word isn''t
 the end of the world.
@@ -22,3 +22,7 @@
 this paragraph needs to
 be changed. Things can
 be added after it.
+
+This paragraph contains
+important new additions
+to this document.'! !

!KMPDiffTest methodsFor: 'accessing' stamp: 'MatthiasJunker 3/5/2010 00:02'!
patchedContent
^'This is an important
notice!! It should
therefore be located at
the beginning of this
document!!

This part of the
document has stayed the
same from version to
version.  It shouldn''t
be shown if it doesn''t
change.  Otherwise, that
would not be helping to
compress anything.

It is important to spell
check this document. On
the other hand, a
misspelled word isn''t
the end of the world.
Nothing in the rest of
this paragraph needs to
be changed. Things can
be added after it.

This paragraph contains
important new additions
to this document.'! !

!KMPDiffTest methodsFor: 'tests' stamp: 'FelipeGonzlezMartnez 1/10/2012 21:09'!
testConstructContentFromDiff
	|  patch |
	patch := PPDiffParser new fileDiff parse: self patch1.
	self assert: ((patch patch: self initialContent allLines) asContent  =  (self patchedContent )).! !

!KMPDiffTest methodsFor: 'tests' stamp: 'FelipeGonzlezMartnez 1/10/2012 23:10'!
testPatch
	| chunk1  diff  content patchedContent |
	
	chunk1 := KMPDiffChunk new.
	diff := KMPDiff new.
	diff chunks: ( Array with:  chunk1 ).
	content := #('a' 'b' 'c' 'd').
	chunk1 oldFileRangeStart: 1 oldFileRangeSize: 3 newFileRangeStart: 1 newFileRangeSize: 3.
	chunk1 content:  { {$- . 'a'} . {$+ . 'a1'} . {Character space . 'b' } . { Character space .'c' } }.
	patchedContent := diff patch: content.
	self assert: patchedContent = #('a1' 'b' 'c' 'd').
	
	"added"
	diff revision: 1.
	diff linesAdded = #('a1').
	diff path: '/tmp'.
	
	self assert: diff numberOfLinesAdded = 1.
	self assert: diff lineNumberDifferenceToPrevious = 0.
	self assert: diff getLogicalIndentation = 0.
	self assert: diff revision = 1.
	self assert: diff linesAdded = #('a1') asOrderedCollection.
	self assert: diff path = '/tmp'.
	"not sure about how this test works"
	self deny: diff content = #(#($- 'a') #($+ 'a1') #(Character space 'b') #(Character space 'c')) asOrderedCollection.
	
	content := #('a1' 'b' 'c' 'd').
	chunk1 oldFileRangeStart: 1 oldFileRangeSize: 3 newFileRangeStart: 1 newFileRangeSize: 3.
	chunk1 content:  { {$- . 'a1'} . {$+ . ''} . {Character space . 'b' } . { Character space .'c' } }.
	patchedContent := diff patch: content.
	diff revision: 2.
	self assert: patchedContent = #('' 'b' 'c' 'd').
	
	self assert: diff numberOfLinesRemoved = 1.
	self assert: diff lineNumberDifferenceToPrevious = 0.
	self assert: diff getLogicalIndentation = 0.
	self assert: diff revision = 2.
	self assert: diff linesRemoved = #('a1') asOrderedCollection.
! !

TestCase subclass: #KMPDirectoryHistoryTest
	instanceVariableNames: 'directoryHistory projectHistory'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Kumpel-Tests-Core'!

!KMPDirectoryHistoryTest methodsFor: 'as yet unclassified' stamp: 'MatthiasJunker 3/10/2011 23:04'!
setUp
	directoryHistory := KMPDirectoryHistory new .
	projectHistory := KMPProjectHistory new.
	directoryHistory projectHistory: projectHistory .! !

!KMPDirectoryHistoryTest methodsFor: 'as yet unclassified' stamp: 'MatthiasJunker 3/10/2011 23:08'!
testConvertToFileHistory
	| testDataBuilder history parentHistory convertedHistory |
	
	testDataBuilder := KMPTestDataBuilder new.
	projectHistory := testDataBuilder projectHistory.
	history := testDataBuilder createAt: 'a/b/c' inRevision: 1.
	history modify: (testDataBuilder  getProjectVersion: 2).
	parentHistory := testDataBuilder projectHistory searchAt: 'a/b' inVersion: 1.   
	
	convertedHistory := history convertToFileHistory.
	
	self assert: convertedHistory isFile.
	self assert: convertedHistory parentHistory  = parentHistory.
	self assert: convertedHistory versions size  = 2.
	self assert:( convertedHistory versions allSatisfy: [:each | each isFile ]).  
	self assert: convertedHistory referenceHistory =  projectHistory.
	self assert: (parentHistory childHistories includes: convertedHistory ).
	self assert: (parentHistory childHistories  includes: history ) not.! !

!KMPDirectoryHistoryTest methodsFor: 'as yet unclassified' stamp: 'MatthiasJunker 3/10/2011 23:08'!
testConvertToFileHistoryRelatedHistories
	| testDataBuilder  replacingHistory replacedHistory abctxt adbctxt |
	testDataBuilder := KMPTestDataBuilder new.
	projectHistory := testDataBuilder projectHistory.
	testDataBuilder createAt: 'a/b/c.txt' inRevision: 1.
	testDataBuilder createAt: 'a/d/b/c.txt' inRevision: 1.
	replacedHistory := projectHistory searchAt: 'a/b' inVersion: 1.
	replacingHistory := projectHistory searchAt: 'a/d/b' inVersion: 1.
	replacedHistory replaceByHistory: replacingHistory inVersion: (testDataBuilder getProjectVersion: 2).
	
	(projectHistory searchAt: 'a/b/c.txt' inVersion: 2) convertToFileHistory.
	(projectHistory searchAt: 'a/d/b/c.txt' inVersion: 2) convertToFileHistory.
	
	abctxt := projectHistory searchAt: 'a/b/c.txt' inVersion: 2.
	adbctxt := projectHistory searchAt: 'a/d/b/c.txt' inVersion: 2.
	self assert: abctxt isFile.
	self assert: adbctxt isFile.
	self assert: abctxt successorHistories isEmpty.
	self assert: abctxt ancestorHistory =   adbctxt.
	self assert: (adbctxt successorHistories includes: abctxt) .
	
	self assert:( (projectHistory searchAt: 'a/b' inVersion: 2) childHistories allSatisfy: #isFile)  .
	self assert:( (projectHistory searchAt: 'a/d/b' inVersion: 2) childHistories allSatisfy: #isFile)  .
! !

!KMPDirectoryHistoryTest methodsFor: 'as yet unclassified' stamp: 'MatthiasJunker 3/10/2011 23:05'!
testExistsAt
	| projectVersion |
	projectVersion := KMPProjectVersion new: 2.
	projectHistory versions add: projectVersion.
	directoryHistory  addRevision: projectVersion.
	
	self assert: (directoryHistory existsAt: 1) not.
	self assert: (directoryHistory existsAt: 2).
	self assert: (directoryHistory existsAt: 3).! !

!KMPDirectoryHistoryTest methodsFor: 'as yet unclassified' stamp: 'MatthiasJunker 3/10/2011 23:05'!
testExistsAtDeleted
	| projectVersion2 projectVersion3 |
	projectVersion2 := KMPProjectVersion new: 2.
	projectVersion3 := KMPProjectVersion new: 3.
	projectHistory versions add: projectVersion2.
	projectHistory versions add: projectVersion3.
	directoryHistory  addRevision: projectVersion2.
	directoryHistory  delete: projectVersion3.
	self assert: (directoryHistory existsAt: 1) not.
	self assert: (directoryHistory existsAt: 2).
	self assert: (directoryHistory existsAt: 3) .
	self assert: (directoryHistory existsAt: 4) not.! !

!KMPDirectoryHistoryTest methodsFor: 'as yet unclassified' stamp: 'MatthiasJunker 3/10/2011 23:05'!
testExistsAtSingleDeleteVersion
	| projectVersion1 projectVersion2 |
	projectVersion1 := KMPProjectVersion new: 1.
	projectVersion2 := KMPProjectVersion new: 2.
	projectHistory versions add: projectVersion1.
	projectHistory versions add: projectVersion2.
	directoryHistory addRevision: projectVersion1.
	directoryHistory  delete: projectVersion2.
	
	self assert: (directoryHistory existsAt: 1)  .
	self assert: (directoryHistory existsAt: 2) .
	self assert: (directoryHistory existsAt: 3) not.! !

!KMPDirectoryHistoryTest methodsFor: 'as yet unclassified' stamp: 'MatthiasJunker 3/10/2011 23:03'!
testExistsAtWithoutVersions
	self assert: (KMPDirectoryHistory new existsAt: 2)! !

!KMPDirectoryHistoryTest methodsFor: 'as yet unclassified' stamp: 'MatthiasJunker 3/10/2011 23:08'!
testReplaceByHistory
	| testDataBuilder directoryHistoryToReplace replacingDirectoryHistory  replacingHistory replacedHistory ancestorHistory |
	testDataBuilder := KMPTestDataBuilder new.
	projectHistory := testDataBuilder projectHistory .
	testDataBuilder createAt: 'a/b/c.txt' inRevision: 1.
	testDataBuilder createAt: 'a/d/b/e.txt' inRevision: 1.
	
	(projectHistory searchAt:  'a/b' inVersion: 1) replaceByHistory: (projectHistory searchAt:  'a/d/b' inVersion: 1) inVersion: (testDataBuilder getProjectVersion: 2 ) .
	
	ancestorHistory := projectHistory searchAt: 'a/d/b/e.txt' inVersion: 2.
	self assert: ancestorHistory notNil.
	
	replacingHistory :=  projectHistory searchAt: 'a/b/e.txt' inVersion: 2.
	self assert: replacingHistory notNil.
	self assert: replacingHistory versions size = 1.
	self assert: replacingHistory versions first action = KMPNodeVersion replaceAction.
	self assert: replacingHistory ancestorHistory = ancestorHistory.
	
	replacedHistory :=  projectHistory searchAt: 'a/b/c.txt' inVersion: 2.
	self assert: replacedHistory isNil.
	

	
! !

!KMPDirectoryHistoryTest methodsFor: 'as yet unclassified' stamp: 'MatthiasJunker 3/10/2011 23:08'!
testReplaceByHistoryWithDifferentName
	| testDataBuilder directoryHistoryToReplace replacingDirectoryHistory  replacingHistory replacedHistory |
	testDataBuilder := KMPTestDataBuilder new.
	projectHistory := testDataBuilder projectHistory .
	testDataBuilder createAt: 'a/b/c.txt' inRevision: 1.
	testDataBuilder createAt: 'a/d/g/e.txt' inRevision: 1.
	
	(projectHistory searchAt:  'a/b' inVersion: 1) replaceByHistory: (projectHistory searchAt:  'a/d/g' inVersion: 1) inVersion: (testDataBuilder getProjectVersion: 2 ) .
	
	replacingHistory :=  projectHistory searchAt: 'a/b/e.txt' inVersion: 2.
	self assert: replacingHistory notNil.
	self assert: replacingHistory versions size = 1.
	self assert: replacingHistory versions first action = KMPNodeVersion replaceAction.
	
	replacedHistory :=  projectHistory searchAt: 'a/b/c.txt' inVersion: 2.
	self assert: replacedHistory isNil.
	
	self assert: (projectHistory searchAt: 'a/d/g/e.txt' inVersion: 2) notNil.
	
! !

TestCase subclass: #KMPFileHistoryTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Kumpel-Tests-Core'!

!KMPFileHistoryTest methodsFor: 'tests' stamp: 'FelipeGonzlezMartnez 1/10/2012 22:25'!
testAddRevision
	| nodeHistory projectHistory projectVersion |
	projectHistory := KMPProjectHistory new.
	projectVersion := KMPProjectVersion new.
	projectHistory versions add: projectVersion.
	nodeHistory := KMPFileHistory new: 'a' asKumpelPath projectHistory: projectHistory parentHistory: KMPDirectoryHistory new.
	nodeHistory addRevision: projectVersion.
	self assert: nodeHistory versions first action = KMPNodeVersion addAction.
	! !

!KMPFileHistoryTest methodsFor: 'tests' stamp: 'FelipeGonzlezMartnez 1/10/2012 22:26'!
testCreateVersion
   | fileHistory projectHistory parentHistory revision projectVersion |
	revision := 1.
	projectHistory := KMPProjectHistory new. 
	projectVersion := KMPProjectVersion new: revision date: nil author: nil.
	projectHistory versions add: projectVersion .
	fileHistory := KMPFileHistory new: 'a' asKumpelPath  projectHistory: projectHistory parentHistory: KMPDirectoryHistory new.
	fileHistory createNewVersion: projectVersion  action: KMPNodeVersion addAction.
	self assert: (fileHistory versions size = 1).
	self assert: fileHistory versions first revision = revision.
	self assert: fileHistory versions first referenceVersion = projectVersion.
	
	"added"
	self assert: fileHistory owner = nil.! !

!KMPFileHistoryTest methodsFor: 'tests' stamp: 'MatthiasJunker 3/10/2011 23:05'!
testDeleteBeforeCreated
	|   nodeHistory |
	nodeHistory := KMPFileHistory new.
	self should: [nodeHistory delete: KMPProjectVersion new] raise: AssertionFailure .! !

!KMPFileHistoryTest methodsFor: 'tests' stamp: 'MatthiasJunker 3/10/2011 23:05'!
testDeleteTwice
	|   nodeHistory |
	nodeHistory := KMPFileHistory new.
	nodeHistory addRevision: KMPProjectVersion new.
	nodeHistory delete: KMPProjectVersion new.
	self should: [nodeHistory delete: KMPProjectVersion new] raise: AssertionFailure .! !

!KMPFileHistoryTest methodsFor: 'tests' stamp: 'FelipeGonzlezMartnez 1/10/2012 22:46'!
testFileExtension
	| fileHistory |
	fileHistory := KMPFileHistory new.
	fileHistory path: 'a/b/c.txt' asKumpelPath.
	self assert: fileHistory fileExtension = 'txt'.
	fileHistory path: 'a/b/noExtension' asKumpelPath.
	self assert: fileHistory fileExtension = ''.
	fileHistory path: 'a/b/strange.file.name.txt' asKumpelPath.
	self assert: fileHistory fileExtension = 'txt'.
	
	"added"
	self assert: fileHistory fileExtensionProperty = 'txt'.
	self assert: fileHistory nodeTypeString = 'F'.
	"not sure about how to put the result"
	self deny: fileHistory convertToFileHistory = 'a/b/strange.file.name.txt'.! !

!KMPFileHistoryTest methodsFor: 'tests' stamp: 'FelipeGonzlezMartnez 1/10/2012 22:26'!
testIsDeleted
	|   nodeHistory |
	nodeHistory := KMPFileHistory new.
	self deny: nodeHistory isDeleted.
	nodeHistory addRevision: KMPProjectVersion new.
	self deny: nodeHistory isDeleted.
	nodeHistory modify: KMPProjectVersion new.
	self deny: nodeHistory isDeleted.
	nodeHistory delete: KMPProjectVersion new.
	self assert: nodeHistory isDeleted.! !

!KMPFileHistoryTest methodsFor: 'tests' stamp: 'FelipeGonzlezMartnez 1/10/2012 23:37'!
testIsFile
	"added"
	| fileHistory |
	fileHistory := KMPFileHistory new.
	
	self assert: fileHistory isFile = true.
	self assert: fileHistory isDirectory = false.! !

TestCase subclass: #KMPFileVersionTest
	instanceVariableNames: 'emptyVersion notMtVersion'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Kumpel-Tests-Core'!

!KMPFileVersionTest methodsFor: 'as yet unclassified' stamp: 'FelipeGonzlezMartnez 1/10/2012 20:53'!
setUp

	emptyVersion := KMPFileVersion new.
	notMtVersion := KMPFileVersion new.
	notMtVersion history: (KMPFileHistory fromPath: '/tmp').! !

!KMPFileVersionTest methodsFor: 'as yet unclassified' stamp: 'FelipeGonzlezMartnez 1/10/2012 20:53'!
testConstructContentFromDiffs

	self assert: notMtVersion constructContentFromDiffs notNil.! !

!KMPFileVersionTest methodsFor: 'as yet unclassified' stamp: 'FelipeGonzlezMartnez 1/2/2012 15:11'!
testEmptyVersionHasNoHistory

	self assert: emptyVersion history isNil! !

!KMPFileVersionTest methodsFor: 'as yet unclassified' stamp: 'FelipeGonzlezMartnez 1/2/2012 15:09'!
testNumberOfLinesAdded

	self assert: emptyVersion numberOfLinesAdded = 0.! !

!KMPFileVersionTest methodsFor: 'as yet unclassified' stamp: 'FelipeGonzlezMartnez 1/2/2012 15:09'!
testNumberOfLinesRemoved

	self assert: emptyVersion numberOfLinesRemoved = 0.! !

TestCase subclass: #KMPNodeHistoryTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Kumpel-Tests-Core'!

!KMPNodeHistoryTest methodsFor: 'as yet unclassified' stamp: 'MatthiasJunker 3/12/2011 23:33'!
testAgeInRevisions
	
	| nodeHistory testDataBuilder |
	testDataBuilder := KMPTestDataBuilder new.
	nodeHistory := testDataBuilder createAt: 'a/b/c.txt' inRevision: 1.
	
	testDataBuilder getProjectVersion: 4.  
	self assert: nodeHistory ageInRevisions = 3.
	
	nodeHistory delete: (testDataBuilder getProjectVersion: 3).
	self assert: nodeHistory ageInRevisions = 2.! !

!KMPNodeHistoryTest methodsFor: 'as yet unclassified' stamp: 'MatthiasJunker 3/10/2011 23:03'!
testAllAncestorHistories
	| nodeHistory ancestor1 ancestor2 allAncestorHistories |
	nodeHistory := KMPNodeHistory fromPath: 'a'.
	ancestor1 := KMPNodeHistory fromPath: 'b'.
	ancestor2 := KMPNodeHistory fromPath: 'c'.
	nodeHistory ancestorHistory: ancestor1.
	ancestor1 ancestorHistory: ancestor2.
	allAncestorHistories := nodeHistory allAncestorHistories.
	self assert: allAncestorHistories size = 2.
	self assert: (allAncestorHistories includes: ancestor1).
	self assert: (allAncestorHistories includes: ancestor1)! !

!KMPNodeHistoryTest methodsFor: 'as yet unclassified' stamp: 'MatthiasJunker 3/10/2011 23:03'!
testAllAncestorHistoriesWithoutAncestors
	| nodeHistory   allAncestorHistories |
	nodeHistory := KMPNodeHistory new.
	allAncestorHistories := nodeHistory allAncestorHistories.
	self assert: allAncestorHistories size = 0.! !

!KMPNodeHistoryTest methodsFor: 'as yet unclassified' stamp: 'MatthiasJunker 3/10/2011 23:03'!
testAllHistories
	| nodeHistory ancestor1 successor1 allHistories |
	nodeHistory := KMPDirectoryHistory fromPath: 'a'.
	ancestor1 := KMPDirectoryHistory fromPath: 'b'.
	successor1 := KMPDirectoryHistory fromPath: 'c'.
	nodeHistory ancestorHistory: ancestor1.
	successor1 ancestorHistory: nodeHistory.
	allHistories := {ancestor1 . successor1 . nodeHistory} asOrderedCollection.
	self assert: (nodeHistory allRelatedHistories includesAll: allHistories).
	self assert: (ancestor1 allRelatedHistories includesAll: allHistories).
	self assert: (successor1 allRelatedHistories includesAll: allHistories)! !

!KMPNodeHistoryTest methodsFor: 'as yet unclassified' stamp: 'MatthiasJunker 3/10/2011 23:03'!
testAllSuccessorHistories
	| nodeHistory successor1 successor2 allSuccessorHistories |
	nodeHistory := KMPNodeHistory fromPath: 'a'.
	successor1 := KMPNodeHistory fromPath: 'b'.
	successor2 := KMPNodeHistory fromPath: 'c'.
	successor1 ancestorHistory:   nodeHistory.
	successor2 ancestorHistory: successor1.
	allSuccessorHistories := nodeHistory allSuccessorHistories.
	self assert: allSuccessorHistories size = 2.
	self assert: (allSuccessorHistories includes: successor1).
	self assert: (allSuccessorHistories includes: successor2)! !

!KMPNodeHistoryTest methodsFor: 'as yet unclassified' stamp: 'MatthiasJunker 3/10/2011 23:03'!
testAllSuccessorHistoriesWithoutSuccessors
	| nodeHistory   allSuccessorHistories |
	nodeHistory := KMPNodeHistory new.
	allSuccessorHistories := nodeHistory allSuccessorHistories.
	self assert: allSuccessorHistories isEmpty .! !

!KMPNodeHistoryTest methodsFor: 'as yet unclassified' stamp: 'FelipeGonzlezMartnez 1/2/2012 14:39'!
testCopyToIn
	| dataBuilder history dirCopy childCopy ancestorHistory |
	dataBuilder := KMPTestDataBuilder new.
	history := dataBuilder createAt: 'a/b/c.txt' inRevision: 1.
	history successorHistories: (OrderedCollection with: ( dataBuilder createAt: 'a/x/c.txt' inRevision: 1)). 
	
	dirCopy := (dataBuilder projectHistory searchAt: 'a/b' inVersion: 1) copyTo: 'a' asKumpelPath  in:  2.
	
	self assert: dirCopy path = 'a' asKumpelPath.
	self assert: dirCopy childHistories size = 1.
	
	childCopy := dirCopy childHistories first.
	ancestorHistory := dataBuilder projectHistory searchAt: 'a/b/c.txt' inVersion: 1.

	self assert: childCopy path = 'a/c.txt' asKumpelPath.
	self assert: childCopy referenceHistory = dataBuilder projectHistory.  
	self assert: childCopy ancestorHistory = ancestorHistory.
	self assert: childCopy ancestorVersion = ancestorHistory versions first.
	self assert: childCopy successorHistories isEmpty.  
	self assert: childCopy versions isEmpty.! !

!KMPNodeHistoryTest methodsFor: 'as yet unclassified' stamp: 'MatthiasJunker 3/12/2011 23:47'!
testDeleteInVersionAt

	| testDataBuilder nodeHistory rootHistory abctxtHistory abHistory |
	testDataBuilder := KMPTestDataBuilder new.
	nodeHistory := testDataBuilder createAt: 'a/b/c.txt' inRevision: 1.  
	rootHistory := testDataBuilder projectHistory rootHistory.
	testDataBuilder projectHistory rootHistory deleteInVersion: (testDataBuilder getProjectVersion: 2 )  at: 'a/b'.
	
	self assert: (rootHistory at: 'a' inVersion: 1) versions last action = KMPNodeVersion addAction.
	
	abHistory := rootHistory at: 'a/b' inVersion: 1.
	self assert: (abHistory) versions last revision = 2.
	self assert: (abHistory) versions last  action =  KMPNodeVersion deleteAction.
	
	abctxtHistory := rootHistory at: 'a/b/c.txt' inVersion: 1.
	self assert: (abctxtHistory) versions last revision = 2.
	self assert: (abctxtHistory) versions last  action =  KMPNodeVersion deleteAction.! !

TestCase subclass: #KMPPathTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Kumpel-Tests-Core'!

!KMPPathTest methodsFor: 'tests' stamp: 'MatthiasJunker 3/12/2010 18:21'!
testAddFirst
	| path1 path2 path3 |
	path1 := 'home/usr/' asKumpelPath .
	path2 := path1 addFirst: 'test'.
	self assert: path2 = 'test/home/usr' asKumpelPath.! !

!KMPPathTest methodsFor: 'tests' stamp: 'Matthias Junker 2/25/2010 23:44'!
testAppend
	| path1 path2  |
	path1 := 'home/usr/' asKumpelPath .
	path2 := 'tmp/test/' asKumpelPath .
	 path1 append: path2.
	self assert: path1 asString = 'home/usr/tmp/test'.! !

!KMPPathTest methodsFor: 'tests' stamp: 'Matthias Junker 2/25/2010 21:07'!
testAsString
	| path |
	self assert:  'a/b' asKumpelPath asString = 'a/b'.
	! !

!KMPPathTest methodsFor: 'tests' stamp: 'MatthiasJunker 3/11/2010 23:52'!
testBeginsWith
	| path1 path2  |
	path1 := 'home/usr/' asKumpelPath .
	path2 := 'home/usr/test' asKumpelPath .
	self assert: (path1 beginsWith: path2) not.
	self assert: (path2 beginsWith: path1) .
	self assert: (path1 beginsWith: path1) .! !

!KMPPathTest methodsFor: 'tests' stamp: 'Matthias Junker 2/25/2010 23:49'!
testConcat
	| path1 path2 path3 |
	path1 := 'home/usr/' asKumpelPath .
	path2 := 'tmp/test/' asKumpelPath.
	path3 := path1 , path2.
	self assert: path3 asString = 'home/usr/tmp/test'.
	self assert: path1  ~= path3.! !

!KMPPathTest methodsFor: 'tests' stamp: 'MatthiasJunker 3/12/2010 18:22'!
testCopy
	| path1 path2 |
	path1 :=  '/test/' asKumpelPath .
	path2 := path1 copy.
	self assert: path1  = path2  .
	self assert: path1 ~~ path2.! !

!KMPPathTest methodsFor: 'tests' stamp: 'MatthiasJunker 3/10/2011 23:03'!
testCreate
	|  path |
	path := KMPPath create: #('a' 'b').
	self  assert: path pathParts first = 'a'.
	self  assert: path pathParts second = 'b'.! !

!KMPPathTest methodsFor: 'tests' stamp: 'MatthiasJunker 3/12/2010 18:23'!
testDepth

	self assert: 'a/b/c' asKumpelPath depth = 3  .
	self assert: '' asKumpelPath  depth  = 0.! !

!KMPPathTest methodsFor: 'tests' stamp: 'MatthiasJunker 3/12/2010 18:24'!
testFirst

	self assert: 'a/b/c' asKumpelPath first  = 'a'.! !

!KMPPathTest methodsFor: 'tests' stamp: 'MatthiasJunker 3/10/2011 23:03'!
testIsEmpty
	
	self deny: 'a/b/c' asKumpelPath isEmpty.
	self assert: '' asKumpelPath isEmpty.
	self assert: KMPPath new isEmpty.! !

!KMPPathTest methodsFor: 'tests' stamp: 'MatthiasJunker 3/12/2011 23:19'!
testName
	self assert:  'a/b.txt' asKumpelPath name = 'b.txt'.
	! !

!KMPPathTest methodsFor: 'tests' stamp: 'FelipeGonzlezMartnez 1/10/2012 22:55'!
testPathOnly
	| path1 path2 |
	path1 := 'a/b/c' asKumpelPath .
	path2 := 'a/b' asKumpelPath.
	self assert:  path1 pathOnly = path2.
	self assert: path1 pathOnly ~~ path1.
 	 ! !

!KMPPathTest methodsFor: 'tests' stamp: 'Matthias Junker 2/25/2010 23:51'!
testRelativeFromPath
	| path1 path2 path3 |
	path1 :=  'home/test1/test2' asKumpelPath  .
	path2 :=  'home/test1' asKumpelPath .
	path3 := path1 getPathRelativeFrom: path2. 
	self assert: path3 asString = 'test2'.! !

!KMPPathTest methodsFor: 'tests' stamp: 'Matthias Junker 2/25/2010 23:53'!
testRelativeFromPath2
	| path1 path2 path3 |
	path1 :=  'home/usr1/test1/test2' asKumpelPath.
	path2 :=  'home/usr1' asKumpelPath .
	path3 := path1 getPathRelativeFrom: path2. 
	self assert: path3 asString = 'test1/test2'.! !

!KMPPathTest methodsFor: 'tests' stamp: 'Matthias Junker 2/25/2010 23:54'!
testRelativeFromPath3
	| path1 path2 path3 |
	path1 :='/home/test1/test2' asKumpelPath.
	path2 :=  'home' asKumpelPath .
	path3 := path1 getPathRelativeFrom: path2. 
	self assert: path3 asString = 'test1/test2'.! !

!KMPPathTest methodsFor: 'tests' stamp: 'FelipeGonzlezMartnez 1/10/2012 22:49'!
testSecond

	self assert: 'a/b/c' asKumpelPath second  = 'b'.! !

!KMPPathTest methodsFor: 'tests' stamp: 'FelipeGonzlezMartnez 1/10/2012 22:55'!
testSplitPath
	"added"
	| path |
	path := 'a/b/c' asKumpelPath.	
	self assert: path splitPath = #('a' 'b' 'c') asOrderedCollection.
 	 ! !

!KMPPathTest methodsFor: 'tests' stamp: 'MatthiasJunker 3/12/2010 18:42'!
testUpTo
	
	self assert: ('a/b/c' asKumpelPath upTo: 2 ) = 'a/b' asKumpelPath.
	self assert: ('a' asKumpelPath upTo: 1 ) = 'a' asKumpelPath.
	self should: ['a' asKumpelPath upTo: 3 ] raise: Error.! !

TestCase subclass: #KMPProjectHistoryTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Kumpel-Tests-Core'!

!KMPProjectHistoryTest methodsFor: 'as yet unclassified' stamp: 'MatthiasJunker 3/13/2011 01:44'!
testAddVersion
	| testDataBuilder nodeHistory projectVersion2 |
	testDataBuilder := KMPTestDataBuilder new.
	projectVersion2 := KMPProjectVersion new: 2.
	testDataBuilder projectHistory addVersion: projectVersion2.
	self assert: projectVersion2 history = testDataBuilder projectHistory.
	self assert: (testDataBuilder projectHistory versions includes: projectVersion2)! !

!KMPProjectHistoryTest methodsFor: 'as yet unclassified' stamp: 'MatthiasJunker 3/13/2011 01:32'!
testHeadVersion
	| testDataBuilder |
	testDataBuilder := KMPTestDataBuilder new.
	testDataBuilder getProjectVersion: 3.
	testDataBuilder getProjectVersion: 1.
	testDataBuilder getProjectVersion: 2.
	self assert: testDataBuilder projectHistory headVersion = (testDataBuilder getProjectVersion: 3)! !

!KMPProjectHistoryTest methodsFor: 'as yet unclassified' stamp: 'MatthiasJunker 3/13/2011 01:46'!
testVersionAt
	| testDataBuilder nodeHistory projectVersion2 |
	testDataBuilder := KMPTestDataBuilder new.
	projectVersion2 := testDataBuilder getProjectVersion: 2  .
	self assert: (testDataBuilder projectHistory versionAt: 2) = projectVersion2.
	! !

!KMPProjectHistoryTest methodsFor: 'as yet unclassified' stamp: 'MatthiasJunker 3/13/2011 01:39'!
testVersionsBetweenAnd
	| testDataBuilder nodeHistory1 nodeHistory2 versions |
	testDataBuilder := KMPTestDataBuilder new.
	nodeHistory1 := testDataBuilder getProjectVersion: 1.
	nodeHistory1 date: '01.02.2001' asDate.
	nodeHistory2 := testDataBuilder getProjectVersion: 2.
	nodeHistory2 date: '01.03.2001' asDate.
	
	self assert: (testDataBuilder projectHistory versionsBetween: '01.01.2001' asDate and: '01.01.2002' asDate) size = 2.
	versions := testDataBuilder projectHistory versionsBetween: '01.01.2001' asDate and: '01.02.2001' asDate.
	self assert: versions size = 1.
	self assert: versions first = nodeHistory1.
	versions := testDataBuilder projectHistory versionsBetween: '01.03.2001' asDate and: '01.03.2001' asDate.
	self assert: versions size = 1.
	self assert: versions first = nodeHistory2! !

TestCase subclass: #KMPProjectVersionTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Kumpel-Tests-Core'!

!KMPProjectVersionTest methodsFor: 'as yet unclassified' stamp: 'MatthiasJunker 3/10/2011 23:05'!
testAddNodeVersion
	| projectVersion fileVersion fileHistory  |
	projectVersion := (KMPProjectVersion new: 1 date: nil author: nil).
	fileVersion := KMPFileVersion new.
	fileHistory := KMPFileHistory new.
	fileVersion history: fileHistory.
	projectVersion addNodeVersion: fileVersion.
	self assert: (projectVersion exactVersions  includes: fileVersion).
	! !

TestCase subclass: #PPInitialListParserTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Kumpel-Tests-Core'!

!PPInitialListParserTest methodsFor: 'as yet unclassified' stamp: 'MatthiasJunker 3/13/2011 01:51'!
testParse
	PPInitialListParser new
		parse:
			'pathString=contrib/servlet-api/servlet-api-2.3src.zip nodeKind=file copyFromPath=null copyFromRevision=-1
pathString=contrib/servlet-api/servlet-api.jar nodeKind=file copyFromPath=null copyFromRevision=-1
pathString=changelog.txt nodeKind=file copyFromPath=null copyFromRevision=-1
'! !

Object subclass: #KMPTestDataBuilder
	instanceVariableNames: 'projectHistory'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Kumpel-Tests-Core'!

!KMPTestDataBuilder methodsFor: 'building' stamp: 'MatthiasJunker 3/10/2011 23:03'!
createAt: aPath inRevision: aRevison
	| currHistory currPath |
	aPath asKumpelPath pathParts
		inject: ''
		into: [ :path :currPathSegment | 
			currPath := (path asKumpelPath , currPathSegment asKumpelPath) .
			currHistory := projectHistory searchAt: currPath inVersion: aRevison.
			currHistory
				ifNil: [ 
					currHistory := KMPDirectoryHistory new: currPath projectHistory: projectHistory .
					currHistory addRevision: (self getProjectVersion: aRevison ).
					projectHistory addHistory: currHistory at: currPath pathOnly inVersion: aRevison.
					 ].
				currPath ].
		^ currHistory ! !

!KMPTestDataBuilder methodsFor: 'building' stamp: 'MatthiasJunker 3/13/2011 01:42'!
getProjectVersion: aRevision
	^ self projectHistory versions
		detect: [ :each | each revision = aRevision ]
		ifNone: [ self projectHistory addVersion: (KMPProjectVersion new: aRevision) ]! !

!KMPTestDataBuilder methodsFor: 'as yet unclassified' stamp: 'MatthiasJunker 3/10/2011 23:04'!
initialize
	projectHistory := KMPProjectHistory new.
	projectHistory rootHistory: ((KMPDirectoryHistory new)
				path: KMPPath new;
				referenceHistory: projectHistory).! !

!KMPTestDataBuilder methodsFor: 'as yet unclassified' stamp: 'MatthiasJunker 3/3/2011 21:32'!
projectHistory
	^ projectHistory ! !
